<template>
  <div class="flex justify-center">
    <div class="full-width q-py-xl q-px-md flex column">
      <q-form
        ref="actualForm"
        @submit.prevent="!isUpdating ? onSubmit() : updateUser()"
        class="q-ma-md"
      >
        <div class="row q-gutter-sm">
          <div class="col-12" style="width: 100%">
            <h4 class="q-my-none q-mb-sm text-pink-10">
              {{ !isUpdating ? "Add User" : "Update User" }}
            </h4>
            <h6 class="q-my-none q-mb-sm text-pink-8">Personal Details</h6>
          </div>
          <div class="row col-12 q-gutter-sm q-mx-none">
            <q-input
              autofocus
              outlined
              v-model="form.name"
              label="Name*"
              placeholder="(eg. Juan Dela Cruz)"
              class="col-12 col-lg-6"
              lazy-rules
              :rules="[
                (val) => (val && val.length > 0) || 'Please type something',
              ]"
              dense
            />
            <q-input
              outlined
              v-model.number="form.number"
              mask="(####) - ### - ####"
              label="Phone number*"
              placeholder="eg. 9123456789"
              class="col-12 col-lg-5"
              lazy-rules
              :rules="[
                (val) => (val && val.length > 0) || 'Please type something',
              ]"
              dense
            />
            <q-input
              outlined
              v-model="form.username"
              label="Username*"
              class="col-12 col-lg-6"
              lazy-rules
              :rules="[
                (val) => (val && val.length > 0) || 'Please type something',
              ]"
              dense
            />
            <q-input
              outlined
              v-model="form.email"
              type="email"
              label="E-mail*"
              placeholder="eg. juandelacruz@gmail.com"
              class="col-12 col-lg-5"
              lazy-rules
              :rules="[
                (val) => (val && val.length > 0) || 'Please type something',
              ]"
              dense
            />
            <q-input
              outlined
              v-model="form.street"
              label="Street*"
              class="col-12 col-lg-3 text-capitalize"
              lazy-rules
              :rules="[
                (val) => (val && val.length > 0) || 'Please type something',
              ]"
              dense
            />
            <q-input
              outlined
              v-model="form.suite"
              label="Suite*"
              class="col-12 col-lg-3 text-capitalize"
              lazy-rules
              :rules="[
                (val) => (val && val.length > 0) || 'Please type something',
              ]"
              dense
            />
            <q-input
              outlined
              v-model="form.city"
              label="City*"
              class="col-12 col-lg-3 text-capitalize"
              lazy-rules
              :rules="[
                (val) => (val && val.length > 0) || 'Please type something',
              ]"
              dense
            />
            <q-input
              outlined
              v-model="form.zipcode"
              mask="####"
              label="Zipcode*"
              class="col-12 col-lg-2"
              lazy-rules
              :rules="[
                (val) => (val && val.length > 0) || 'Please type something',
              ]"
              dense
            />
          </div>
          <div class="col-12" style="width: 100%">
            <h6 class="q-my-none q-mb-sm text-pink-8">Business Details</h6>
          </div>
          <div class="row col-12 q-gutter-sm q-mx-none">
            <q-input
              outlined
              v-model="form.company"
              label="Company Name*"
              class="col-12 col-lg-6"
              lazy-rules
              :rules="[
                (val) => (val && val.length > 0) || 'Please type something',
              ]"
              dense
            />
            <q-input
              outlined
              type="website"
              v-model="form.website"
              label="Website"
              class="col-12 col-lg-5"
              dense
            />
            <q-input
              outlined
              v-model="form.catchphrase"
              label="Catchphrase"
              class="col-12 col-lg-6"
              dense
            />
            <q-input
              outlined
              v-model="form.bs"
              label="Business Services*"
              class="col-12 col-lg-5"
              lazy-rules
              :rules="[
                (val) => (val && val.length > 0) || 'Please type something',
              ]"
              dense
            />
          </div>
          <q-btn
            class="q-ml-md"
            outline
            color="pink-10"
            :label="!isUpdating ? 'Submit' : 'Update'"
            type="submit"
            :loading="btnLoadingState"
            no-caps
          />

          <q-btn
            v-if="idNum"
            outline
            rounded
            color="primary"
            label="Cancel"
            type="submit"
            to="/"
          />
        </div>
      </q-form>
    </div>
  </div>
</template>

<script>
// Imports
import { ref } from "vue";
import { useRouter } from "vue-router";
import axios from "axios";
import { user, isUpdating, form, id } from "../Composables/Pages";

export default {
  setup() {
    const router = useRouter(); // router for pushing new content

    let actualForm = ref(null);

    let btnLoadingState = ref(false);

    const onSubmit = () => {
      btnLoadingState.value = true;

      let newUser = {
        name: form.value.name,
        username: form.value.username,
        email: form.value.email,
        address: {
          street: form.value.street,
          suite: form.value.suite,
          city: form.value.city,
          zipcode: form.value.zipcode,
        },
        number: form.value.number,
        website: form.value.website,
        company: {
          companyName: form.value.company,
          catchPhrase: form.value.catchphrase,
          bs: form.value.bs,
        },
      };

      axios.post("http://localhost:3000/users", newUser).then((response) => {
        /** HTTP
         *
         * 2** - SUCCESS
         * 4** - CLIENT ERROR
         */
        if (response.status === 201) {
          actualForm.value.reset();

          form.value = {
            name: null,
            username: null,
            email: null,
            street: null,
            suite: null,
            city: null,
            zipcode: null,
            number: null,
            website: null,
            company: null,
            catchphrase: null,
            bs: null,
          };
        }
        btnLoadingState.value = false;
        //inputFocus.value.focus();
      });
    };

    let userInfoUpdate = (user) => {
      idNum.value = user.id;
      name.value = user.name;
      username.value = user.username;
      email.value = user.email;
      street.value = user.address.street;
      suite.value = user.address.suite;
      city.value = user.address.city;
      zipcode.value = user.address.zipcode;
      number.value = user.number;
      website.value = user.website;
      companyName.value = user.company.company;
      catchPhrase.value = user.company.catchphrase;
      bs.value = user.company.bs;
    };

    let idNum = ref(null);

    let updateUser = () => {
      btnLoadingState.value = true;

      let newUser = {
        name: form.value.name,
        username: form.value.username,
        email: form.value.email,
        address: {
          street: form.value.street,
          suite: form.value.suite,
          city: form.value.city,
          zipcode: form.value.zipcode,
        },
        number: form.value.number,
        website: form.value.website,
        company: {
          companyName: form.value.company,
          catchPhrase: form.value.catchphrase,
          bs: form.value.bs,
        },
      };

      // http://localhost:3000/users - POST AND GET
      // http://localhost:3000/users/:id
      /**
       * FOUR COMMON HTTP REQUEST METHODS:
       * GET, POST, PUT, DELETE
       *
       * RESPONSE TYPES:
       * JSON, HTML, XML, Etc.
       */
      axios
        .put(`http://localhost:3000/users/${id.value}`, newUser)
        .then((response) => {
          if (response.status >= 200) {
            id.value = null;

            actualForm.value.reset();
            form.value = {
              name: null,
              username: null,
              email: null,
              street: null,
              suite: null,
              city: null,
              zipcode: null,
              number: null,
              website: null,
              company: null,
              catchphrase: null,
              bs: null,
            };
            router.push("/list-of-users"); // for redirecting
          }

          btnLoadingState.value = false;
        })
        .catch((err) => {
          btnLoadingState.value = false;
          // display message that you have an error.
        });
    };

    return {
      isUpdating,
      actualForm,
      onSubmit,
      form,
      btnLoadingState,
      user,
      updateUser,
      idNum,
      userInfoUpdate,
    };
  },
};
</script>
